// 16. 最接近的三数之和
// 给定一个包括 n 个整数的数组 nums 和 一个目标值 target。找出 nums 中的三个整数，使得它们的和与 target 最接近。返回这三个数的和。假定每组输入只存在唯一答案。
// https://leetcode-cn.com/problems/3sum-closest

//Rust实现
impl Solution {
    pub fn three_sum_closest(nums: Vec<i32>, target: i32) -> i32 {
        let mut temp = nums.clone();
        temp.sort();
        let (mut l, mut i, mut r): (i32, i32, i32) = (0, 1, 0);
        let mut sum: i32 = 0;
        let mut ret: i32 = 99999999;
        while (i as usize) < temp.len()-1 {    
            l = i - 1;
            r = i + 1;
            while l >= 0 && (r as usize) < temp.len() {
                sum = temp[i as usize ] + temp[l as usize ] + temp[r as usize];
                if sum == target {
                    return sum;
                }
                if sum > target {
                    l -= 1;
                } else {
                    r += 1;
                }
                if (sum - target).abs() < (ret - target).abs() {
                    ret = sum;
                }
            } 
            i += 1;
        }
        ret
    }
}

//C++实现
// class Solution {
// public:
//     int threeSumClosest(vector<int>& nums, int target) {
// 	sort(nums.begin(), nums.end());//排序 n*lgn 
// 	int near_res = INT_MAX;
// 	int result = 0;
// 	for (int i = 0; i < nums.size()-2; i++)
// 	{
// 		int j = i + 1, k = nums.size() - 1;
// 		while (j < k)//O(n^2)，双指针
// 		{
// 			if (near_res > abs(nums[i] + nums[j] + nums[k] - target))//找最接近的数
// 			{
// 				near_res = abs(nums[i] + nums[j] + nums[k] - target);
// 				result = nums[i] + nums[j] + nums[k];
// 			}
// 			if (nums[i] + nums[j] + nums[k] < target)//小值往后增加
// 			{
// 				j++;
// 			}
// 			else if (nums[i] + nums[j] + nums[k] == target)//大值往前减少
// 				return target;
// 			else
// 				k--;
// 		}
// 	}
// 	return result;

//     }
// };