// 搜索二维矩阵
// 编写一个高效的算法来判断 m x n 矩阵中，是否存在一个目标值。该矩阵具有如下特性：
// 每行中的整数从左到右按升序排列。
// 每行的第一个整数大于前一行的最后一个整数。
// https://leetcode-cn.com/problems/search-a-2d-matrix

// Rust实现
impl Solution {
    pub fn search_matrix(matrix: Vec>, target: i32) -> bool {
        let (m, n) = (matrix.len(), matrix[0].len());
        let (mut left, mut right) = (0, (m * n - 1) as i32);
        while (left <= right) {
            let mid = (left + right) / 2;
            if matrix[mid as usize / n][mid as usize % n] == target {
                return true;
            } else if matrix[mid as usize / n][mid as usize % n] > target {
                right = mid - 1;
            } else {
                left = mid + 1;
            }
        }
        false
    }
}

// C++实现
// class Solution {
// public:
//     bool searchMatrix(vector<vector<int>>& matrix, int target) {
//         int m = matrix.size(), n = matrix[0].size(), left = 0, right = m * n - 1;
//         while (left <= right) {
//             int mid = (left + right) / 2;
//             if (matrix[mid / n][mid % n] == target) return true;
//             else if (matrix[mid / n][mid % n] > target) right = mid - 1;
//             else left = mid + 1;
//         }
//         return false;
//     }
// }; 