# Notes

- [Notes](#notes)
  - [生命周期](#生命周期)
    - [省略规则](#生命周期注解省略规则)
    - [static生命周期](#所有字符字面值都拥有static生命周期)

## 生命周期
```
//生命周期，避免悬垂引用,结构体中使用
#[derive(Debug)]
struct A<'a>{
    name:&'a str,
}
fn main() {
    let n= String::from("hello");
    let a = A{
        name:&n
    };
    println!("a={:#?}",a);

    println!("Hello,world!");
}
//生命周期省略
fn get_a_str(s:&str)->&str{
    s
}
```
### 生命周期注解省略规则
生命周期注解省略规则适用于fn定义以及impl块定义，如下  
a、每个引用的参数都有它自己的生命周期参数。例如：一个引用参数的函数，其中有一个生命周期:
fn foo<'a>(x: &'a 132)；
两个引用参数的函数，则有两个生命周期: fn foo<'a,b>(x: &'a i32， y: &'b i32)以此类推。  
b、如果只有一个输入生命周期参数，那么它被赋予所有输出生命周期参数:fn foo(x: &i32) -> &i32
等,价于fn foo<'a>(x: &'a 132)-> &'a i32  
c、如果方法有多个输入生命周期参数，不过其中之一因为方法的缘故为&self或者&mut self, 那seLf的生>期被 赋予所有输出生命周期参数。
### 所有字符字面值都拥有static生命周期
```
let s:&'static str="hello";
```
